/***********************************************************************************
*                               C_INPUT_MODULE                                     *
*                                                                                  *
*                                                                                  *
* Este  o testbench de envio de dados para outros roteadores da NOC.              *
* O nmero de roteadores que vo ser testados podem ser configurados a partir do   *
* parmetro NROT, WIDTH E HEIGHT da NOC. Devem ser inseridos novos processos pa-   *
* ra cada roteador adicionado. O testbench procura no diretorio em que esta exe-   *
* cutando arquivos no seguinte formato: "inXX.txt". Onde XX significa o nmero     *
* do roteador a ser simulado. guinte sequencia:                                    *
* - 1 byte: destino do pacote                                                      *
* - 1 byte: numero de palavras                                                     *
* - 1 byte: origem do pacote                                                       *
* - 4 bytes: tempo de saida do pacote                                              *
* - N bytes: dado                                                                  *
* - 4 bytes: tempo de chegada do pacote em hexadecimal                             *
* - 1 int: tempo de chegada do pacote em inteiro                                   *
* - 1 int: tempo em que o cabealho levou para chegar no destino                   *
* - 1 int: tempo em que todo o pacote levou para chegar no destino                 *
*                                                                                  *
***********************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mti.h"
#include "conv_mvl9.h"
#include "math.h"

//nmero de CHAVES a simular
#define NROT 25
#define TAM_FLIT 16

#define WIDTH 5
#define HEIGHT 5

//interface hardware-software typedef struct
typedef struct
{
	mtiSignalIdT clk, reset;
	mtiSignalIdT ack_tx_ext[NROT];
	mtiDriverIdT out_ext[NROT];
	mtiDriverIdT tx_ext[NROT];
}
signals_reg;

//global declaretion
FILE *g_inputfile[NROT];
FILE *output;
char g_reset, g_clk;
char g_out_ext[NROT][TAM_FLIT], g_tx_ext[NROT], g_ack_tx_ext[NROT], tx_aux[NROT];
char palavra[NROT];
int dado[NROT], count[NROT], end_file[NROT], timestamp_source[NROT][4], state[NROT], size[NROT],waittime[NROT];
unsigned long int counter_clock;

//function prototypes
void c_input_module_init(mtiRegionIdT region,char *param,mtiInterfaceListT *generics,mtiInterfaceListT *ports);
void process(signals_reg *sr, int var);

void proc_clock_CB0(signals_reg *sr);
void proc_clock_CB1(signals_reg *sr);
void proc_clock_CB2(signals_reg *sr);
void proc_clock_CB3(signals_reg *sr);
void proc_clock_CB4(signals_reg *sr);
void proc_clock_CB5(signals_reg *sr);
void proc_clock_CB6(signals_reg *sr);
void proc_clock_CB7(signals_reg *sr);
void proc_clock_CB8(signals_reg *sr);
void proc_clock_CB9(signals_reg *sr);
void proc_clock_CB10(signals_reg *sr);
void proc_clock_CB11(signals_reg *sr);
void proc_clock_CB12(signals_reg *sr);
void proc_clock_CB13(signals_reg *sr);
void proc_clock_CB14(signals_reg *sr);
void proc_clock_CB15(signals_reg *sr);
void proc_clock_CB16(signals_reg *sr);
void proc_clock_CB17(signals_reg *sr);
void proc_clock_CB18(signals_reg *sr);
void proc_clock_CB19(signals_reg *sr);
void proc_clock_CB20(signals_reg *sr);
void proc_clock_CB21(signals_reg *sr);
void proc_clock_CB22(signals_reg *sr);
void proc_clock_CB23(signals_reg *sr);
void proc_clock_CB24(signals_reg *sr);


int hexa_converte_decimal(char *numero);
int getNext(int var);
void getTimestamp(int var);
int dec_to_nodo(int value);

void c_input_module_init(mtiRegionIdT region,char *param,mtiInterfaceListT *generics,mtiInterfaceListT *ports)
{
	signals_reg *sr;
	mtiProcessIdT proc_clock[NROT];
	int i;
	char temp[15];

	sr = (signals_reg *) malloc(sizeof(signals_reg));
	mti_AddRestartCB(free, sr);

	sr->clk  = mti_FindPort(ports, "clk");
	sr->reset = mti_FindPort(ports, "reset");

	for(i=0;i<NROT;i++)
	{
		sprintf(temp, "ack_tx_ext%d",i);
		sr->ack_tx_ext[i] = mti_FindPort(ports, temp);

		sprintf(temp, "out_ext%d",i);
		sr->out_ext[i] = mti_CreateDriver(mti_FindPort(ports, temp));

		sprintf(temp, "tx_ext%d",i);
		sr->tx_ext[i] = mti_CreateDriver(mti_FindPort(ports, temp));

		sprintf (temp, "in%d.txt" ,i);

		if((g_inputfile[i] = fopen(temp, "rw")) == NULL )
		{
			printf("ARQUIVO INEXISTENTE\n");
			end_file[i]=1;
		}
		else
			end_file[i]=0;
		count[i]=0;
		waittime[i]=0;
	}

	proc_clock[0]= mti_CreateProcess("process0", (void*)proc_clock_CB0, sr);
	proc_clock[1]= mti_CreateProcess("process1", (void*)proc_clock_CB1, sr);
	proc_clock[2]= mti_CreateProcess("process2", (void*)proc_clock_CB2, sr);
	proc_clock[3]= mti_CreateProcess("process3", (void*)proc_clock_CB3, sr);
	proc_clock[4]= mti_CreateProcess("process4", (void*)proc_clock_CB4, sr);
	proc_clock[5]= mti_CreateProcess("process5", (void*)proc_clock_CB5, sr);
	proc_clock[6]= mti_CreateProcess("process6", (void*)proc_clock_CB6, sr);
	proc_clock[7]= mti_CreateProcess("process7", (void*)proc_clock_CB7, sr);
	proc_clock[8]= mti_CreateProcess("process8", (void*)proc_clock_CB8, sr);
	proc_clock[9]= mti_CreateProcess("process9", (void*)proc_clock_CB9, sr);
	proc_clock[10]= mti_CreateProcess("process10", (void*)proc_clock_CB10, sr);
	proc_clock[11]= mti_CreateProcess("process11", (void*)proc_clock_CB11, sr);
	proc_clock[12]= mti_CreateProcess("process12", (void*)proc_clock_CB12, sr);
	proc_clock[13]= mti_CreateProcess("process13", (void*)proc_clock_CB13, sr);
	proc_clock[14]= mti_CreateProcess("process14", (void*)proc_clock_CB14, sr);
	proc_clock[15]= mti_CreateProcess("process15", (void*)proc_clock_CB15, sr);
	proc_clock[16]= mti_CreateProcess("process16", (void*)proc_clock_CB16, sr);
	proc_clock[17]= mti_CreateProcess("process17", (void*)proc_clock_CB17, sr);
	proc_clock[18]= mti_CreateProcess("process18", (void*)proc_clock_CB18, sr);
	proc_clock[19]= mti_CreateProcess("process19", (void*)proc_clock_CB19, sr);
	proc_clock[20]= mti_CreateProcess("process20", (void*)proc_clock_CB20, sr);
	proc_clock[21]= mti_CreateProcess("process21", (void*)proc_clock_CB21, sr);
	proc_clock[22]= mti_CreateProcess("process22", (void*)proc_clock_CB22, sr);
	proc_clock[23]= mti_CreateProcess("process23", (void*)proc_clock_CB23, sr);
	proc_clock[24]= mti_CreateProcess("process24", (void*)proc_clock_CB24, sr);


	for(i=0;i<NROT;i++)
	{
		mti_Sensitize(proc_clock[i], sr->clk, MTI_EVENT);
		mti_Sensitize(proc_clock[i], sr->reset, MTI_EVENT);
	}
}

void proc_clock_CB0(signals_reg *sr)
{
	g_reset = convert_enum_to_mvl9_char(mti_GetSignalValue(sr->reset));
	g_clk   = convert_enum_to_mvl9_char(mti_GetSignalValue(sr->clk));

	//sempre incrementa o clock
	if(g_clk=='1' && g_reset=='0')
		counter_clock++;

	process(sr, 0);
}

void proc_clock_CB1 (signals_reg *sr){process(sr , 1 );}
void proc_clock_CB2 (signals_reg *sr){process(sr , 2 );}
void proc_clock_CB3 (signals_reg *sr){process(sr , 3 );}
void proc_clock_CB4 (signals_reg *sr){process(sr , 4 );}
void proc_clock_CB5 (signals_reg *sr){process(sr , 5 );}
void proc_clock_CB6 (signals_reg *sr){process(sr , 6 );}
void proc_clock_CB7 (signals_reg *sr){process(sr , 7 );}
void proc_clock_CB8 (signals_reg *sr){process(sr , 8 );}
void proc_clock_CB9 (signals_reg *sr){process(sr , 9 );}
void proc_clock_CB10 (signals_reg *sr){process(sr , 10 );}
void proc_clock_CB11 (signals_reg *sr){process(sr , 11 );}
void proc_clock_CB12 (signals_reg *sr){process(sr , 12 );}
void proc_clock_CB13 (signals_reg *sr){process(sr , 13 );}
void proc_clock_CB14 (signals_reg *sr){process(sr , 14 );}
void proc_clock_CB15 (signals_reg *sr){process(sr , 15 );}
void proc_clock_CB16 (signals_reg *sr){process(sr , 16 );}
void proc_clock_CB17 (signals_reg *sr){process(sr , 17 );}
void proc_clock_CB18 (signals_reg *sr){process(sr , 18 );}
void proc_clock_CB19 (signals_reg *sr){process(sr , 19 );}
void proc_clock_CB20 (signals_reg *sr){process(sr , 20 );}
void proc_clock_CB21 (signals_reg *sr){process(sr , 21 );}
void proc_clock_CB22 (signals_reg *sr){process(sr , 22 );}
void proc_clock_CB23 (signals_reg *sr){process(sr , 23 );}
void proc_clock_CB24 (signals_reg *sr){process(sr , 24 );}
void proc_clock_CB25 (signals_reg *sr){process(sr , 25 );}


void process(signals_reg *sr, int var)
{
	g_reset = convert_enum_to_mvl9_char(mti_GetSignalValue(sr->reset));
	g_clk   = convert_enum_to_mvl9_char(mti_GetSignalValue(sr->clk));
	g_ack_tx_ext[var] = convert_enum_to_mvl9_char(mti_GetSignalValue(sr->ack_tx_ext[var]));

	if(g_reset=='1')
	{

		if(end_file[var]==1)
		{
			tx_aux[var]=0;
			dado[var]=0;
		}
		else
		{
			tx_aux[var]=0;
			if(count[var]==0)
			{
				waittime[var]=getNext(var);
				
				//se for fim do arquivo para tudo
				if(feof(g_inputfile[var]))
					end_file[var]=1;
				else
				{
					//printf("reset waittime[%d]=%d\n",var,waittime[var]);
					//captura o endereco destino
					dado[var]=getNext(var);
				}
			}
			count[var]++;
			counter_clock=0;
			state[var]=1;
		}
	}
	else
	{
		if(g_clk=='1')
		{
			if(end_file[var]==1)
			{
				tx_aux[var] = 0;
				dado[var] = 0;
			}
			else if(waittime[var]!=0)
			{
				//esperando n ciclos
				// Pacote com 100 flits gasta 200 ciclos para ser enviado
				// carga de 50% o G (tempo entre pacote)  igual a 200 ciclos
				waittime[var]--;
			}
			else if(g_ack_tx_ext[var]=='0' && !feof(g_inputfile[var]))
			{
				tx_aux[var] = 1;
			}
			else if(g_ack_tx_ext[var]=='1' && !feof(g_inputfile[var]))
			{
				tx_aux[var] = 0;

				if(state[var]==1)
				{
					//capturando nmero de flits do arquivo de entrada
					dado[var]=getNext(var);

					//capturando o tempo de saida do pacote
					getTimestamp(var);

					//armazena o tamanho do pacote
					size[var]=dado[var];

					//adicionando 5 flits (1 origem e 4 timestamp)
					dado[var]=dado[var] + 5;

					state[var]++;
				}
				else if(state[var]==2)
				{
					//endereco de origem
					dado[var]=dec_to_nodo(var);
					state[var]++;
				}
				else if(state[var] >= 3 && state[var] <= 6)
				{
					//enviando o timestamp
					dado[var] = timestamp_source[var][6 - state[var]];
					state[var]++;
				}
				else
				{
				    //enviando o payload
					if(size[var] > 0)
					{
						//capturando dado do arquivo de entrada
						dado[var] = getNext(var);

						//decrementando o numero de flits a enviar
						size[var]--;
					}
					else
					{
						//capturando proxima wait time
						waittime[var] = getNext(var);
						
						//se for fim do arquivo para tudo
						if(feof(g_inputfile[var]))
							end_file[var]=1;
						else
						{
							//printf("waittime[%d]=%d\n",var,waittime[var]);

							//captura o endereco destino
							dado[var] = getNext(var);
							
							state[var]=1;

						}
					}
				}
			}
			else
				end_file[var]=1;

		}
	}

	convert_int_to_enums(dado[var], g_out_ext[var], TAM_FLIT);
	convert_int_to_enums(tx_aux[var], &g_tx_ext[var], 1);
	mti_ScheduleDriver(sr->tx_ext[var], (long)g_tx_ext[var], 0, MTI_INTERNAL);
	mti_ScheduleDriver(sr->out_ext[var], (long)g_out_ext[var], 0, MTI_INTERNAL);
}

void getTimestamp(int var)
{
	unsigned long int result;
	int i,j,l,total,stamp[TAM_FLIT];

	//estado atual 1 (2o. flit -> tamanho do pacote)
	result = counter_clock - 2;
	
	for(i=0;i<TAM_FLIT;i++)
	{
		stamp[i] = result % 16;
		result = result / 16;
	}

	for(i=0,j=0;i<4;i++,j=j+4) //4  o nmero de flits correspondente ao timestamp
	{
		total = 0;
		for(l=j;l< (j + (TAM_FLIT/4));l++) //(TAM_FLIT/4)  o tamflit em hexa
		{
			total = total + stamp[l]* pow(2,(l*4));
		}
		timestamp_source[var][i] = total;
	}
}

int hexa_converte_decimal(char *numero)
{
    int i, j, tam, dec, hexa,decimal=0;
    tam = strlen(numero);
    for (i = 0, j = tam - 1; i < tam; i++, j--)
    {
        switch (numero[i])
        {
        	case '0':
        	{ hexa = 0; break; }
        	case '1':
        	{ hexa = 1; break; }
        	case '2':
        	{ hexa = 2; break; }
        	case '3':
        	{ hexa = 3; break; }
        	case '4':
        	{ hexa = 4; break; }
        	case '5':
            { hexa = 5; break; }
        	case '6':
            { hexa = 6; break; }
        	case '7':
            { hexa = 7; break; }
        	case '8':
            { hexa = 8; break; }
        	case '9':
            { hexa = 9; break; }
        	case 'A':
            { hexa = 10; break; }
        	case 'B':
            { hexa = 11; break; }
        	case 'C':
            { hexa = 12; break; }
        	case 'D':
            { hexa = 13; break; }
        	case 'E':
            { hexa = 14; break; }
        	case 'F':
            { hexa = 15; break; }
        	default:
            { break; }
        }
        dec = hexa * (pow(16, j));
        decimal = decimal + dec;
    }
    return decimal;
}

int getNext(int var)
{
	if(!feof(g_inputfile[var]))
	{
		fscanf(g_inputfile[var],"%s",palavra);
		dado[var]=hexa_converte_decimal(palavra);
	}
	else
	{
		if(count[var]==0)
		{
			end_file[var]=1;
			return 0;
		}
		count[var]=0;
	}
	return dado[var];
}

//funcao para converter de decimal para o address do nodo
int dec_to_nodo(int value)
{
	//Calcula a posicao na NOC
	int posX=value%WIDTH;
	int posY=value/HEIGHT;
	return posX*10+posY;
}
