/*----------------------------------------------------------

            MVL9 (std_logic) Conversion Utility

  Author : CSA & VLSI Design Lab.
           Kyunghee Univ. Dept. of Electronics

  Purpose : ModelSim FLI utility

  Filename : conv_mvl9.h
  Comment  :

------------------------------------------------------------*/

#include <stdio.h>

/******************************************************
 The following set of routines is used for converting STD_LOGIC
 and STD_LOGIC_VECTORs from their internal representations
 (ordinal positions in the enerated type for std_logic)
 to the character values (X, 0, 1, ...) and vice-versa.
*/
extern char mvl9_char[];

char convert_enum_to_bool_char(int enum_bit);
int  convert_bool_char_to_enum(char b_char);

char convert_enum_to_mvl9_char(int enum_bit);
void convert_enums_to_mvl9_string(char *enums, char *string, int len);
void convert_mvl9_string_to_enums(char *string, char *enums, int len);

/********************************************************************
	Convert Integer to MVL9 String
*********************************************************************/
void convert_int_to_mvl9_string(long num, char *string, int len);
long convert_mvl9_str_to_int(char *string, int len);
long convert_int_to_enums( long num, char *enums, int len);
long convert_enums_to_int(char *enums, int len);
