library IEEE;
use IEEE.std_logic_1164.all;
use ieee.std_logic_arith.CONV_STD_LOGIC_VECTOR;
use work.HermesPackage.all;
   entity top is
end;

architecture top of top is

	signal clk, reset : std_logic;
	signal data_in, data_out : arrayNrot_regflit;
	signal rx, ack_rx, tx, ack_tx : regNrot;

begin
	reset <= '1', '0' after 15 ns;
	process
	begin
		clk <= '1', '0' after 10 ns;
		wait for 20 ns;
	end process;

	NOC: Entity work.NOC(NOC)
	port map(
		clock        => clk,
		reset        => reset,
		data_outLocal=> data_out,
		txLocal      => tx,
		ack_txLocal  => ack_tx,
		data_inLocal => data_in,
		rxLocal      => rx,
		ack_rxLocal  => ack_rx);

	cim00: Entity work.c_input_module(c_input_module)
	port map(
		clk => clk,
		reset=> reset,
		out_ext0 => data_in(N0000),
		tx_ext0  => rx(N0000),
		ack_tx_ext0 => ack_rx(N0000),
		out_ext1 => data_in(N0100),
		tx_ext1  => rx(N0100),
		ack_tx_ext1 => ack_rx(N0100),
		out_ext2 => data_in(N0200),
		tx_ext2  => rx(N0200),
		ack_tx_ext2 => ack_rx(N0200),
		out_ext3 => data_in(N0300),
		tx_ext3  => rx(N0300),
		ack_tx_ext3 => ack_rx(N0300),
		out_ext4 => data_in(N0400),
		tx_ext4  => rx(N0400),
		ack_tx_ext4 => ack_rx(N0400),
		out_ext5 => data_in(N0001),
		tx_ext5  => rx(N0001),
		ack_tx_ext5 => ack_rx(N0001),
		out_ext6 => data_in(N0101),
		tx_ext6  => rx(N0101),
		ack_tx_ext6 => ack_rx(N0101),
		out_ext7 => data_in(N0201),
		tx_ext7  => rx(N0201),
		ack_tx_ext7 => ack_rx(N0201),
		out_ext8 => data_in(N0301),
		tx_ext8  => rx(N0301),
		ack_tx_ext8 => ack_rx(N0301),
		out_ext9 => data_in(N0401),
		tx_ext9  => rx(N0401),
		ack_tx_ext9 => ack_rx(N0401),
		out_ext10 => data_in(N0002),
		tx_ext10  => rx(N0002),
		ack_tx_ext10 => ack_rx(N0002),
		out_ext11 => data_in(N0102),
		tx_ext11  => rx(N0102),
		ack_tx_ext11 => ack_rx(N0102),
		out_ext12 => data_in(N0202),
		tx_ext12  => rx(N0202),
		ack_tx_ext12 => ack_rx(N0202),
		out_ext13 => data_in(N0302),
		tx_ext13  => rx(N0302),
		ack_tx_ext13 => ack_rx(N0302),
		out_ext14 => data_in(N0402),
		tx_ext14  => rx(N0402),
		ack_tx_ext14 => ack_rx(N0402),
		out_ext15 => data_in(N0003),
		tx_ext15  => rx(N0003),
		ack_tx_ext15 => ack_rx(N0003),
		out_ext16 => data_in(N0103),
		tx_ext16  => rx(N0103),
		ack_tx_ext16 => ack_rx(N0103),
		out_ext17 => data_in(N0203),
		tx_ext17  => rx(N0203),
		ack_tx_ext17 => ack_rx(N0203),
		out_ext18 => data_in(N0303),
		tx_ext18  => rx(N0303),
		ack_tx_ext18 => ack_rx(N0303),
		out_ext19 => data_in(N0403),
		tx_ext19  => rx(N0403),
		ack_tx_ext19 => ack_rx(N0403),
		out_ext20 => data_in(N0004),
		tx_ext20  => rx(N0004),
		ack_tx_ext20 => ack_rx(N0004),
		out_ext21 => data_in(N0104),
		tx_ext21  => rx(N0104),
		ack_tx_ext21 => ack_rx(N0104),
		out_ext22 => data_in(N0204),
		tx_ext22  => rx(N0204),
		ack_tx_ext22 => ack_rx(N0204),
		out_ext23 => data_in(N0304),
		tx_ext23  => rx(N0304),
		ack_tx_ext23 => ack_rx(N0304),
		out_ext24 => data_in(N0404),
		tx_ext24  => rx(N0404),
		ack_tx_ext24 => ack_rx(N0404)
	);
	com00: Entity work.c_output_module(c_output_module)
	port map(
		clk => clk,
		reset=> reset,
		in_ext0 => data_out(N0000),
		rx_ext0 => tx(N0000),
		ack_rx_ext0 => ack_tx(N0000),
		in_ext1 => data_out(N0100),
		rx_ext1 => tx(N0100),
		ack_rx_ext1 => ack_tx(N0100),
		in_ext2 => data_out(N0200),
		rx_ext2 => tx(N0200),
		ack_rx_ext2 => ack_tx(N0200),
		in_ext3 => data_out(N0300),
		rx_ext3 => tx(N0300),
		ack_rx_ext3 => ack_tx(N0300),
		in_ext4 => data_out(N0400),
		rx_ext4 => tx(N0400),
		ack_rx_ext4 => ack_tx(N0400),
		in_ext5 => data_out(N0001),
		rx_ext5 => tx(N0001),
		ack_rx_ext5 => ack_tx(N0001),
		in_ext6 => data_out(N0101),
		rx_ext6 => tx(N0101),
		ack_rx_ext6 => ack_tx(N0101),
		in_ext7 => data_out(N0201),
		rx_ext7 => tx(N0201),
		ack_rx_ext7 => ack_tx(N0201),
		in_ext8 => data_out(N0301),
		rx_ext8 => tx(N0301),
		ack_rx_ext8 => ack_tx(N0301),
		in_ext9 => data_out(N0401),
		rx_ext9 => tx(N0401),
		ack_rx_ext9 => ack_tx(N0401),
		in_ext10 => data_out(N0002),
		rx_ext10 => tx(N0002),
		ack_rx_ext10 => ack_tx(N0002),
		in_ext11 => data_out(N0102),
		rx_ext11 => tx(N0102),
		ack_rx_ext11 => ack_tx(N0102),
		in_ext12 => data_out(N0202),
		rx_ext12 => tx(N0202),
		ack_rx_ext12 => ack_tx(N0202),
		in_ext13 => data_out(N0302),
		rx_ext13 => tx(N0302),
		ack_rx_ext13 => ack_tx(N0302),
		in_ext14 => data_out(N0402),
		rx_ext14 => tx(N0402),
		ack_rx_ext14 => ack_tx(N0402),
		in_ext15 => data_out(N0003),
		rx_ext15 => tx(N0003),
		ack_rx_ext15 => ack_tx(N0003),
		in_ext16 => data_out(N0103),
		rx_ext16 => tx(N0103),
		ack_rx_ext16 => ack_tx(N0103),
		in_ext17 => data_out(N0203),
		rx_ext17 => tx(N0203),
		ack_rx_ext17 => ack_tx(N0203),
		in_ext18 => data_out(N0303),
		rx_ext18 => tx(N0303),
		ack_rx_ext18 => ack_tx(N0303),
		in_ext19 => data_out(N0403),
		rx_ext19 => tx(N0403),
		ack_rx_ext19 => ack_tx(N0403),
		in_ext20 => data_out(N0004),
		rx_ext20 => tx(N0004),
		ack_rx_ext20 => ack_tx(N0004),
		in_ext21 => data_out(N0104),
		rx_ext21 => tx(N0104),
		ack_rx_ext21 => ack_tx(N0104),
		in_ext22 => data_out(N0204),
		rx_ext22 => tx(N0204),
		ack_rx_ext22 => ack_tx(N0204),
		in_ext23 => data_out(N0304),
		rx_ext23 => tx(N0304),
		ack_rx_ext23 => ack_tx(N0304),
		in_ext24 => data_out(N0404),
		rx_ext24 => tx(N0404),
		ack_rx_ext24 => ack_tx(N0404)
	);
end top;